import 'package:dart_eval/dart_eval_bridge.dart';
import 'package:dart_eval/src/eval/runtime/runtime.dart';
import 'package:dart_eval/src/eval/shared/stdlib/core/base.dart';
import 'package:dart_eval/src/eval/shared/stdlib/core/collection.dart';

class $RegExp implements $Instance {
  static const $type = BridgeTypeRef.spec(BridgeTypeSpec('dart:core', 'RegExp'));
  static const $declaration = BridgeClassDef(BridgeClassType($type), constructors: {
    '': BridgeConstructorDef(BridgeFunctionDef(returns: BridgeTypeAnnotation($type), params: [
      BridgeParameter('source', BridgeTypeAnnotation(BridgeTypeRef.type(RuntimeTypes.stringType)), false)
    ], namedParams: [
      BridgeParameter('multiLine', BridgeTypeAnnotation(BridgeTypeRef.type(RuntimeTypes.boolType)), true),
      BridgeParameter('caseSensitive', BridgeTypeAnnotation(BridgeTypeRef.type(RuntimeTypes.boolType)), true),
      BridgeParameter('unicode', BridgeTypeAnnotation(BridgeTypeRef.type(RuntimeTypes.boolType)), true),
      BridgeParameter('dotAll', BridgeTypeAnnotation(BridgeTypeRef.type(RuntimeTypes.boolType)), true),
    ]))
  }, methods: {
    'hasMatch': BridgeMethodDef(BridgeFunctionDef(
        returns: BridgeTypeAnnotation(BridgeTypeRef.type(RuntimeTypes.boolType)),
        params: [BridgeParameter('input', BridgeTypeAnnotation(BridgeTypeRef.type(RuntimeTypes.stringType)), false)])),
    'allMatches': BridgeMethodDef(BridgeFunctionDef(
        returns: BridgeTypeAnnotation(BridgeTypeRef.type(RuntimeTypes.iterableType)),
        params: [BridgeParameter('input', BridgeTypeAnnotation(BridgeTypeRef.type(RuntimeTypes.stringType)), false)])),
    'firstMatch': BridgeMethodDef(BridgeFunctionDef(
        returns: BridgeTypeAnnotation($Match.$type),
        params: [BridgeParameter('input', BridgeTypeAnnotation(BridgeTypeRef.type(RuntimeTypes.stringType)), false)])),
  }, getters: {}, setters: {}, fields: {});

  $RegExp.wrap(this.$value);

  @override
  final RegExp $value;

  @override
  $Value? $getProperty(Runtime runtime, String identifier) {
    switch (identifier) {
      case 'hasMatch':
        return $Function(((runtime, target, args) => $bool($value.hasMatch(args[0]!.$value))));
      case 'allMatches':
        return $Function(((runtime, target, args) =>
            $List.wrap($value.allMatches(args[0]!.$value).map((e) => $Match.wrap(e)).toList())));
      case 'firstMatch':
        return $Function(((runtime, target, args) => $Match.wrap($value.firstMatch(args[0]!.$value)!)));
    }
  }

  @override
  get $reified => $value;

  @override
  int get $runtimeType => throw UnimplementedError();

  @override
  void $setProperty(Runtime runtime, String identifier, $Value value) {
    // TODO: implement $setProperty
  }
}

class $Match implements $Instance {
  static const $type = BridgeTypeRef.spec(BridgeTypeSpec('dart:core', 'Match'));
  static const $declaration = BridgeClassDef(BridgeClassType($type), constructors: {}, methods: {
    'group': BridgeMethodDef(BridgeFunctionDef(
        returns: BridgeTypeAnnotation(BridgeTypeRef.type(RuntimeTypes.stringType), nullable: true),
        params: [BridgeParameter('group', BridgeTypeAnnotation(BridgeTypeRef.type(RuntimeTypes.intType)), false)])),
    'groups': BridgeMethodDef(
        BridgeFunctionDef(returns: BridgeTypeAnnotation(BridgeTypeRef.type(RuntimeTypes.listType)), params: [
      BridgeParameter(
          'groupIndices',
          BridgeTypeAnnotation(
              BridgeTypeRef.type(RuntimeTypes.listType, [BridgeTypeRef.type(RuntimeTypes.stringType)])),
          false)
    ])),
  }, getters: {
    'groupCount': BridgeMethodDef(
        BridgeFunctionDef(returns: BridgeTypeAnnotation(BridgeTypeRef.type(RuntimeTypes.intType)), params: [])),
  }, setters: {}, fields: {});

  $Match.wrap(this.$value);

  @override
  final Match $value;

  @override
  $Value? $getProperty(Runtime runtime, String identifier) {
    // TODO: implement $getProperty
    throw UnimplementedError();
  }

  @override
  // TODO: implement $reified
  get $reified => throw UnimplementedError();

  @override
  // TODO: implement $runtimeType
  int get $runtimeType => throw UnimplementedError();

  @override
  void $setProperty(Runtime runtime, String identifier, $Value value) {
    // TODO: implement $setProperty
  }
}
